//Copyright 2000 Dan Van Derveer
// CueCat Barcode decrypter Version 0.02 Alpha

// Bits By Mike Dillon
// All parts by M. Dillon, are GPLed

// Much credit given to Kevin Fowlks who wrote functions in Perl that
// this program is based on.

/*
  Changes in ver .02
  ------------------

  checking for bad inputs (ie. you only got the first half of a
     ISBN code)

  "bool" type now used on decodetext() and seperatesections()

  Giant "if" chains in single/doubleletter() replaced
     with switch-case statements. With much appreciation from Dan

  Several comments added

  "badcode" is defined as 10 for lack of a better number, to
     be used as a notice of a bad decode.

  "endarray" is defined as 987, used as a '\0' would be used in a
     char array

  The decode loop dies immediately after a bad decode.

  Minor Output display changes.
*/


#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#define badcode 10   //used if the decode isnt the list
#define endarray 987  //used like a '\0' in a char[]

bool decodetext(char input[], int output[]);
bool seperatesections(char original[],char partone[],char parttwo[], char partthree[]);
int singleletter(char string);
int doubleletter(char string[2]);
void printout(int data[]);

int main(void) {
	char input[100];
	char partone[40];
	char parttwo[10];
	char partthree[60];
	int final[30];
	cout << ":Cue:Cat Barcode decoder"<<endl;
	cout << "Enter barcode: ";
	cin.get(input,100);

	if( (seperatesections(input,partone,parttwo,partthree)) && (decodetext(partthree,final)) )
		printout(final);         //if statement checks for bad codes
  	else
   		cout << "Error with Barcode!"<<endl;  //Blasthphemy!!
	return 0;
}
void printout(int data[]) { //just spits the barcode back out,just for now
	int i=0;
	cout << "This UPC or ISBN number is: ";
	do {
		cout << data[i]<< " ";
		i++;
	} while(data[i] != endarray);    //used like a '\0'
	cout << '\n';
}

bool decodetext(char input[], int output[]) {
	int outcount=0;    //total number of items in output[]
	int dbswitch=2;    //every 3rd digit is encoded with 2 characters,
                      //starting with the first character.
	int i;
	int leng;
	char temp[2];      //used to pass two letters to doubleletter()
	leng=strlen(input);
	for(i=0;i<leng;i++) {
		if(dbswitch==2) {
			temp[0]=input[i];
			temp[1]=input[i + 1];
			output[outcount]=doubleletter(temp);
			outcount++;
			i++;               //you do remember taking two chars, right?
			dbswitch=0;
		}
		else {
			output[outcount]=singleletter(input[i]);
			dbswitch++;
			outcount++;
		}
		if(output[outcount-1] == badcode) {
			return false; //Well lets see if johnny can scan a barcode right next time...
		}
	}
	output[outcount]=endarray;    //used similar to a '\0'
   return(true);            //Nothing stopped the loop, everything is good
}
// Here is my little split function, Maybe someone could point me to a more 
// efficient way to do this?
bool seperatesections(char original[],char partone[],char parttwo[], char partthree[]) {
	int length,count=1,outcount=0;
	length = strlen(original);
	while(original[count]!='.' && count <= length) { //first '.' ends the first section
		partone[outcount] = original[count];
		count++;
		outcount++;
	}
	partone[outcount]='\0';
	outcount=0;
	count++;
	while(original[count]!='.' && count <= length) { //a '.' seperates all the sections
		parttwo[outcount] = original[count];
		count++;
		outcount++;
	}
	parttwo[outcount]='\0';
	outcount = 0;
	count++;
	while(original[count]!='.' && count <= length) {
		partthree[outcount] = original[count];
		count++;
		outcount++;
	}
	partthree[outcount]='\0';
	if(outcount == 0)
       return (false);   //put to use now.
	else {
		return (true);
	}
}


int singleletter(char string) {
   switch(string){
   case 'n' :
   case 'Z' : return(0);
   case 'j' :
   case 'Y' : return(1);
   case 'f' :
   case 'X' : return(2);
   case 'b' :
   case 'W' : return(3);
   case 'D' :
   case '3' : return(4);
   case 'z' :
   case '2' : return(5);
   case 'v' :
   case '1' : return(6);
   case 'r' :
   case '0' : return(7);
   case 'T' :
   case '7' : return(8);
   case 'P' :
   case '6' : return(9);
   default: return(badcode);  //What??! A Bad Barcode??
   }
}

int doubleletter(char string[2]) {

   switch(string[0]){
   case 'C' :
		switch(string[1]){
      case '3' : return(0);      //notice the 3-N-x-h repeat
      case 'N' : return(1);
      case 'x' : return(2);
      case 'h' : return(3);
      default: return(badcode);  //What??! A Bad Barcode??
      }
	case 'D' :
		switch(string[1]){
      case '3' : return(4);
      case 'N' : return(5);
      case 'x' : return(6);
      case 'h' : return(7);
      default: return(badcode);  //What??! A Bad Barcode??
      }
   case 'E' :
		switch(string[1]){
      case '3' : return(8);
      case 'N' : return(9);
      default: return(badcode);  //What??! A Bad Barcode??
      }
   default: return(badcode);  //What??! A Bad Barcode??
	}
}


